<template>
  <div v-if="pagesNumber" class="row items-center">
    <MSelect
      :main-design="'borderless'"
      :options-dense="true"
      :hide-bottom-space="true"
      v-model="form.rowsPerPage"
      :options="[1,2,3,4,5,10,15,20,25,50,100,150,200]"
      option-value="id"
      option-label="name">
    </MSelect>
    <q-pagination
      v-model="form.page"
      :max="pagesNumber"
      input
      input-class="text-orange-10"
      size="12px"
    />
  </div>
</template>

<script>
  import MSelect from '../forms/MSelect'

  export default {
    name: 'MPagination',
    components: {MSelect},
    model: {
      prop: 'value',
      event: 'input',
    },
    props: {
      value: {
        type: [Object],
        /* {
           sortBy: 'created_at',
           descending: true,
           page: 1,
           rowsPerPage: 20,
           //rowsNumber: 0,
         }*/
      },
    },
    data () {
      return {
        current: 3,
        form: {
          ...this.value,
        },
      }
    },
    methods: {

      //this.$emit('input', val)

      firstRowIndex () {
        const {page, rowsPerPage} = this.computedPagination
        return (page - 1) * rowsPerPage
      },

      lastRowIndex () {
        const {page, rowsPerPage} = this.computedPagination
        return page * rowsPerPage
      },

      isFirstPage () {
        return this.computedPagination.page === 1
      },

      isLastPage () {
        return this.lastRowIndex === 0
          ? true
          : this.computedPagination.page >= this.pagesNumber
      },
    },

    computed: {
      pagesNumber () {
        //console.warn('form changed ', this.form)
        if (!this.value) {
          // eslint-disable-next-line vue/no-side-effects-in-computed-properties
          this.form.page = 1
          return 1
        }
        return this.form.rowsPerPage === 0
          ? 1
          : Math.max(
            1,
            Math.ceil(this.value.rowsNumber / this.form.rowsPerPage),
          )
      },
    },

    watch: {
      value: {
        //console.warn('MPagination:watch ', val)
        handler: function (val, oldVal) {
          this.form.rowsNumber = this.value.rowsNumber
          this.form.sortBy = this.value.sortBy
          this.form.page = this.value.page
          this.form.rowsPerPage = this.value.rowsPerPage
        },
        deep: true,
      },

      form: {
        handler: function (val, oldVal) {
          //console.warn('mPagination watch ', this.mPagination)
          this.$emit('input', val)
        },
        deep: true,
      },
    },

    mounted () {
      // console.warn('form MPagination', this.value)
    },
  }
</script>
